#     Procedura per ridurre i flat speciali di SOFI
#     Leo Vanzi Gennaio 2000

#
#

procedure special_flat(image_list)

string    image_list    {prompt="list of input images"}
string    output        {prompt="output flat frame"}
struct    *flist

begin

#   start loop to read image names from the input file
     i=1

     list = image_list
     while( fscan(list, s1) != EOF ) {
        print(s1)
        imcopy(s1,"temp"//i//".fits")
        i=i+1
     } 

#   average images taken in the same conditions
     imcombine("temp1.fits,temp8.fits",output="temp_off.fits")
     imcombine("temp2.fits,temp7.fits",output="temp_off_mask.fits")
     imcombine("temp3.fits,temp6.fits",output="temp_on_mask.fits")
     imcombine("temp4.fits,temp5.fits",output="temp_on.fits")

#   create the bias correction for the flat-on according to the
#   Lidman technique
     blkavg(input="temp_on.fits[500:600,*]",output="temp_onA.fits",option="average",b1=101,b2=1)
     blkavg(input="temp_on_mask.fits[500:600,*]",output="temp_onC.fits",option="average",b1=101,b2=1)
     blkavg(input="temp_on_mask.fits[50:150,*]",output="temp_onB.fits",option="average",b1=101,b2=1)
     
     imarith("temp_onA.fits","-","temp_onC.fits","temp_onAC.fits")
     imarith("temp_onAC.fits","+","temp_onB.fits","temp_onACB.fits")

     blkrep(input="temp_onACB.fits",output="temp_onACB_2D.fits",b1=1024,b2=1)

     imarith("temp_on.fits","-","temp_onACB_2D.fits","temp_on_bias.fits")

#   same as above for the flat-off
     blkavg(input="temp_off.fits[500:600,*]",output="temp_offA.fits",option="average",b1=101,b2=1)
     blkavg(input="temp_off_mask.fits[500:600,*]",output="temp_offC.fits",option="average",b1=101,b2=1)
     blkavg(input="temp_off_mask.fits[50:150,*]",output="temp_offB.fits",option="average",b1=101,b2=1)
     
     imarith("temp_offA.fits","-","temp_offC.fits","temp_offAC.fits")
     imarith("temp_offAC.fits","+","temp_offB.fits","temp_offACB.fits")

     blkrep(input="temp_offACB.fits",output="temp_offACB_2D.fits",b1=1024,b2=1)

     imarith("temp_off.fits","-","temp_offACB_2D.fits","temp_off_bias.fits")

#   create the corrected flat-field
     imarith("temp_on_bias.fits","-","temp_off_bias.fits",output)

#   normalize the flat-field
     normalize(output)

#  delete the temporary images
   imdelete("temp*.fits",yes,ver-)

end
